//------------------------------------------------------------------------------------------
// OpenGL Matrix Server
//------------------------------------------------------------------------------------------
private import opengl;
private import openglu;
private import util.vector;




class CMatrixSaver
{
private:
    int     viewport[4];
    double  modelview[16];
    double  projection[16];


//  constructor
//--------------------------------------------------
public:
    // default
	this()
    {
        save();
	}
	

//  operation
//--------------------------------------------------
public:
	// save matrix
    void save()
    {
        glGetIntegerv(GL_VIEWPORT,          viewport.ptr);
        glGetDoublev (GL_MODELVIEW_MATRIX,  modelview.ptr);
        glGetDoublev (GL_PROJECTION_MATRIX, projection.ptr);
    }
    
    
	// restore matrix
	void restore()
    {
        int mode;
        glGetIntegerv(GL_MATRIX_MODE, &mode);
        
        glMatrixMode(GL_MODELVIEW);
        glLoadMatrixd(modelview.ptr);
        glMatrixMode(GL_PROJECTION);
        glLoadMatrixd(projection.ptr);

        glMatrixMode(mode);
    }
    

// get saved matrix
//--------------------------------------------------
public:
    double[] getModelViewMatrix()
    {
        return modelview;
    }

    double[] getProjectionMatrix()
    {
        return projection;
    }

    void getModelViewMatrix(matrix4* m)
    {
        for (int i=0; i<16; i++) m.e[i] = cast(float)(modelview[i]);
    }

    void getProjectionMatrix(matrix4* m)
    {
        for (int i=0; i<16; i++) m.e[i] = cast(float)(projection[i]);
    }
    
	double* GetScreenNormal()
	{
		return null;
	}


public:
	// translate world to screen
    void project(inout float dstx, inout float dsty, float srcx, float srcy, float srcz)
    {
/*
        double x, y, z;
        
        gluProject(cast(double)srcx, cast(double)srcy, cast(double)srcz, 
                   modelview, projection, viewport, 
                   &x, &y, &z);
                   
        dstx = cast(float)(x-viewport[2]*0.5);
        dsty = cast(float)(y-viewport[3]*0.5);
*/
    }


    // translate world to screen
    void project(vector2* dstv, vector3* srcv)
    {
        project(srcv.x, srcv.y, srcv.z, dstv.x, dstv.y);
    }


	// translate screen to world
    void unproject(inout float dstx, inout float dsty, inout float dstz, float srcx, float srcy, float srcz)
    {
/*
        double x, y, z;
        
        gluUnProject(cast(double)srcx, cast(double)srcy, cast(double)srcz,
                     modelview, projection, viewport, 
                     &x, &y, &z);
                     
        dstx = cast(float)(x-viewport[2]*0.5);
        dsty = cast(float)(y-viewport[3]*0.5);
        dstz = cast(float)z;
*/
    }


    // translate screen to world
    void unproject(vector3* dstv, vector3* srcv)
    {
        unproject(srcv.x, srcv.y, srcv.z, dstv.x, dstv.y, dstv.z);
    }
};

    
    