//--------------------------------------------------------------------------------
//  Fiber base class
//--------------------------------------------------------------------------------
module util_sd.fiber;


//--------------------------------------------------------------------------------
//  Fiber base class
//--------------------------------------------------------------------------------
abstract class IFiber
{
//--------------------------------------------------
//  Member values
//--------------------------------------------------
private:
    bool    m_isActive = true;


//--------------------------------------------------
//  Member functions
//--------------------------------------------------
public:
    // Constructor
    this() {}
    
    
    // Activate fiber
    void activate() { m_isActive = true; }


    // Inactivate fiber
    void inactivate() { m_isActive = false; }


    // Is fiber active ?
    bool isActive() { return m_isActive; }

    
//--------------------------------------------------
//  virtual function
//--------------------------------------------------
public:
    // System calls this before entering main loop.
    void enter() {}
    
    
    // System calls this after exiting main loop.
    void exit() {}
    
    
    // System calls this after changing scene index.
    void enterScene() {}
    
    
    // System calls this before changing scene index.
    void exitScene() {}


    // System calls this each frame regularly.
    void run() {}
    
    
    // System calls this each frame, but skipping when delayed.
    void draw() {}    
}

