//--------------------------------------------------------------------------------
//  SDL Joystick Wrapping Class
//    Copyright  (C)  2005  kei mesuda  
//    (http://www.yomogi.sakura.ne.jp/~si)
//--------------------------------------------------------------------------------
module util_sdl.joystick;

private import sdl;


class CSDLJoystick
{
private:
    SDL_Joystick*   m_pJoystick;
    

public:
    this()
    {
        m_pJoystick = null;
    }
    

    this(int idx)
    {
        open(idx);
    }

    
    ~this()
    {
        close();
    }


public:
    bool open(uint idx)
    {
        m_pJoystick = SDL_JoystickOpen(idx);
        return isOpened();
    }
    

    void close()
    {
        if (m_pJoystick == null) SDL_JoystickClose(m_pJoystick);
        m_pJoystick = null;
    }
    
    
    bool isOpened()
    {
        return (m_pJoystick != null);
    }
    
    
    int getXAxis()
    {
        return SDL_JoystickGetAxis(m_pJoystick, 0);
    }

    
    int getYAxis()
    {
        return SDL_JoystickGetAxis(m_pJoystick, 1);
    }

    
    int getZAxis()
    {
        return SDL_JoystickGetAxis(m_pJoystick, 2);
    }
    
    
    bool isPressed(int button_idx)
    {
        return (SDL_JoystickGetButton(m_pJoystick, button_idx) != 0);
    }
    
    
    SDL_Joystick* getPointer()
    {
        return m_pJoystick;
    }
};

